

int strobeLed[] = {14,15,16,17}; // Bright Blue
int extLed[] = {14,15,16,17,18,19}; // (Ext)ra LEDs (1-4 are Blue brights 5 & 6 are greens in groups of 2
int ledpin[] ={3,5,6,9,10,11}; // PWM pins
int x = 0;
int y = 0; 
int n = 0; //speed counter.
int i =0; // repeater.
int pulse;
int value[] ={0,0,0,0,0,0}; //lighting amount array for faders
int led = 13;
int recVal = 0;
int pwmBright = 0;
int pwmCounter = 0;
float decaySpd = 1;
boolean riseCheck = true;
float skpMod = 1;
unsigned long strobeCount = 0;
unsigned long nextStrobe = 1000; // Interval for Strobe
int strobeState = LOW;
boolean shortStrobe = false;
boolean strobeCheck = false;
int prevRec = 1;
boolean strobeMe = true;

const int NUMLEDS = 12;
byte pin[NUMLEDS] = {3,5,6,9,10,11,14,15,16,17,18,19}; // All LEDs
byte state[NUMLEDS] = {LOW, LOW, LOW, LOW,LOW, LOW, LOW, LOW,LOW, LOW, LOW, LOW};
unsigned long interval[NUMLEDS] = {60, 50, 70, 45, 80, 65, 40, 50, 55, 35, 51, 59};
unsigned long time[NUMLEDS];

void LEDCheck( int chkDelay, int midDelay ){

     for (x=0; x< 6; x++)
   {
     digitalWrite(extLed[x],HIGH); // I light up consecutively the LEDs
     delay(chkDelay);            // This time variable controles how fast I light them up
   }
        for (x=0; x< 6; x++)
   {
     digitalWrite(ledpin[x],HIGH); // I light up consecutively the LEDs
     delay(chkDelay);            // This time variable controles how fast I light them up
   }
      delay(midDelay);

   for (x=0; x< 6; x++)
   {
     digitalWrite(ledpin[x],LOW); // I light up consecutively the LEDs
     delay(chkDelay);            // This time variable controles how fast I light them up
   }   
   for (x=0; x< 6; x++)
   {
     digitalWrite(extLed[x],LOW); // I light up consecutively the LEDs
     delay(chkDelay);            // This time variable controles how fast I light them up
   }} 

     
void setup()
{
strobeCount = millis();
Serial.begin(9600);
LEDCheck(125,250);
}

// Keepers - Settings I want to keep
// Setting Parms // // dir, skipSteps, loopDelay, loopDelay, fadeSpeed, brightness, Strobe On / Off
//  { pwmSet(1,10,1,decaySpd,pwmBright); }  // Scrolling with PWM
//  { pwmSet(1,20,0,3,150); }  // Super Fast w Slight Ripple
//  { pwmSet(1,20,0,5,150); }  // Super Fast w Firm Ripple 1
//  { pwmSet(1,20,0,8,150); }  // Super Fast w Firm Ripple 2
//   { pwmSet(1,20,0,20,150); }  // Super Fast w Firm Ripple 3

//  { pwmSet(1,10,1,5,150); }  // Good Basic Crawl - Med Speed
//  { pwmSet(1,5,2,1,150); } // Good Basic Crawl - Really Slow Speed - Firm Ripple
// Pulses
// Setting Parms // // Low Brightness. High Brihtness, Delay
//   { pulseAll(2,200,1750); } // Very Slow Pulses
//   { pulseAll(2,200,300); }  //  Med Speed Bright  

void loop(){
serialCheck();
// Lightning Flavors
if (recVal == '0') {blackout(); }
 else if (recVal == '1') { pwmSet(1,5,2,1,150,1); } // Good Basic Crawl - Really Slow Speed - Firm Ripple
 else if (recVal == '2') { pwmSet(1,20,5,3,150,1); } 
 else if (recVal == '3') { pwmSet(1,10,1,5,150,1); } 
 else if (recVal == '4') { pwmSet(1,10,1,decaySpd,pwmBright,1);} 
 else if (recVal == '5') { pwmSet(1,10,1,decaySpd,pwmBright,1);} 
 else if (recVal == '6') { pwmSet(1,20,0,20,150,1);} // Changed Fade Speed
 else if (recVal == 'q') { pulseAll(2,250,1750); } 
 else if (recVal == 'w') { pulseAll(2,250,1000); } 
 else if (recVal == 'e') { pulseAll(2,200,200); }
 else if (recVal == 'r') { pulseAll(2,50,200); }
 else if (recVal == 'b') { blueBlink(1); }
 else if (recVal == 'n') { blueBlinkRound(1); }
 else if (recVal == 'o') { greenOn(); }
 else if (recVal == 'p') { greenOff(); }
 else if (recVal == 'k') { blueOn(); }
 else if (recVal == 'l') { blueOff(); }
 else if (recVal == 's') { strobeMe = true; recVal = prevRec;}
 else if (recVal == 'a') { strobeMe = false; recVal = prevRec;}
 else if (recVal == 'z') { crazyTown(); } 

// Strobe Function
if (millis() - strobeCount > nextStrobe){
strobeCount = millis();
if (shortStrobe == true){shortStrobe = false;} else if (shortStrobe == false){shortStrobe = true;}
if (shortStrobe == true){nextStrobe = 30; strobeState = HIGH;}
else if (shortStrobe == false){ nextStrobe = 1000; strobeState = LOW; strobeCheck =true;}
}
if (strobeMe == true){
 if (strobeCheck == true){
     for (x=0; x< 4; x++){
digitalWrite(strobeLed[x],strobeState); // I light up consecutively the LEDs
 } strobeCheck =false; }}

pwmCounter++;
if (pwmCounter == 4 ) {pwmCounter = 0;
if (riseCheck == true) {pwmBright ++;
if (pwmBright == 255) {riseCheck = false;}
} else if (riseCheck == false) {pwmBright --;
if (pwmBright == 10) {riseCheck = true;}
}}
skpMod  = map(pwmBright, 10, 255, 2, .5);
decaySpd = map(pwmBright, 10, 255, 1, 3.5);

} /// END LOOP

 void sendReport(char reply){  // For Sending Report Back to Sender That The Message Was Recieved
Serial.print( reply );}

void serialCheck(){
if (Serial.available() >0){
if (recVal != 'o' && recVal != 'p' && recVal != 'k' && recVal != 'l', recVal != 's', recVal != 'a'){
prevRec = recVal;}
recVal = Serial.read();
sendReport(recVal);
if (recVal == '1' || recVal == '2' || recVal == '3' || recVal == '4' || recVal == '6'){strobeMe = true;}
if (prevRec == 'z'){blackout();}
if (prevRec == 'z' && recVal == '5'){for (x=0; x< 6; x++){digitalWrite(extLed[x],HIGH);} strobeMe = false;}
if (prevRec == 'z' && recVal == 'q'){for (x=0; x< 6; x++){digitalWrite(extLed[x],HIGH);} strobeMe = false;}
}} // end of Serial Check

void crazyTown(){
 unsigned long m = millis();

 for (int i=0; i<NUMLEDS; ++i)
   if (m - time[i] > interval[i])
   {
     time[i] = m;
     state[i] = state[i] == LOW ? HIGH : LOW;
     digitalWrite(pin[i], state[i]);

}if (millis() - strobeCount > 4000){recVal = 4;}}

void blueBlink(int b){
if (prevRec != 'o'){blackout();
for (x=0; x< b; x++){
   for (y=0; y< 4; y++){
digitalWrite(strobeLed[y],HIGH);
} delay(30);
   for (y=0; y< 4; y++){
digitalWrite(strobeLed[y],LOW);
}delay(1000);}}}
   
void blueBlinkRound(int b){
int old;
for (x=0; x< b; x++){
   for (y=0; y< 4; y++){
digitalWrite(strobeLed[y],HIGH);
if (x==1){old = 4;}
digitalWrite(strobeLed[old],LOW);
old = y;
delay(250);}
digitalWrite(strobeLed[old],LOW);   
}}
   
void greenOn(){digitalWrite(extLed[4],HIGH); digitalWrite(extLed[5],HIGH);recVal = prevRec;}  
void greenOff(){digitalWrite(extLed[4],LOW); digitalWrite(extLed[5],LOW);recVal = prevRec;}  

void blueOn(){digitalWrite(extLed[0],HIGH); digitalWrite(extLed[1],HIGH); digitalWrite(extLed[2],HIGH); digitalWrite(extLed[3],HIGH); recVal = prevRec; strobeMe = false;}  
void blueOff(){digitalWrite(extLed[0],LOW); digitalWrite(extLed[1],LOW); digitalWrite(extLed[2],LOW); digitalWrite(extLed[3],LOW); recVal = prevRec;}  

   
void blackout(){for (i  = 0; i <=5; i++){analogWrite(ledpin[i], 0);} // end Blackout
     for (x=0; x< 6; x++){digitalWrite(extLed[x],LOW); // I light up consecutively the LEDs
   }}
   
void pulseAll(int loLev, int hiLev, int delayNum){
for(pulse = loLev ; pulse <= hiLev; pulse+=1){  // fade in (from min to max) 
 for (i  = 0; i <=5; i++){ // for output to pins.
     analogWrite(ledpin[i], pulse);           // sets the value
     delayMicroseconds(delayNum);
 //    delay(delayNum);     
  }}
    delay(300);
    serialCheck();
     for(pulse = hiLev; pulse >= loLev; pulse-=1)   // fade out (from max to min) 
  { for (i  = 0; i <=5; i++){
    analogWrite( ledpin[i], pulse);           // sets the value

     delayMicroseconds(delayNum+500);
    //delay(delayNum);  
    }}
    delay(150);
  } // end pulseAll

   
void pwmSet(int pwmDir, int skipSteps, int loopDelay, float fadeSpeed, int brightness, int strobeOn){
if (strobeOn == 1){strobeCheck = true;}
else if (strobeOn == 0 ) {strobeCheck = false;}

if (strobeMe == true){strobeCheck = true;}
else if (strobeMe == false){strobeCheck = false;}

switch (pwmDir){
  case 1:
  if( n == 200 ){ value[0] = brightness; }  //// Forward Direction
  if( n == 400 ){ value[1] = brightness; }
  if( n == 600 ){ value[2] = brightness; }
  if( n == 800 ){ value[3] = brightness; }
  if( n == 1000 ){ value[4] = brightness; }
  if( n == 1200 ){ value[5] = brightness; }
  if( n >= 1200 ){ n =0; }
  break;
  
 case 2:
 if( n == 100 ) { value[0]=brightness;}  ////// Back and Forth
  if( n == 200 ) { value[0]=brightness;}
  if( n == 300 ) { value[1]=brightness;}
  if( n == 400 ) { value[2]=brightness;}
  if( n == 500 ) { value[3]=brightness;}
  if( n == 600 ) { value[4]=brightness;}
  if( n == 700 ) { value[5]=brightness;}
  if( n == 800 ) { value[5]=brightness;}
  if( n == 900 ) { value[4]=brightness;}
  if( n == 1000 ) { value[3]=brightness;}
  if( n == 1100 ) { value[2]=brightness;}
  if( n == 1200 ) { value[1]=brightness;}
  if( n >= 1200 ) { n =0;}
  break;
  
 case 3:  
  if( n == 200 ) { value[5] = brightness; }   ////    Reverse
  if( n == 400 ) { value[4] = brightness; }
  if( n == 600 ) { value[3] = brightness; }
  if( n == 800 ) { value[2] = brightness; }
  if( n == 1000 ) { value[1] = brightness; }
  if( n == 1200 ) { value[0] = brightness; }
  if( n >= 1200 ) { n =0; }
  break;
  }
 
  //fade all pins
  for (i  = 0; i <=5; i++){
    if(value[i] >= 5){ value[i]-=fadeSpeed;}
    else if (value[i] < 5) { value[i]=0;}
  }
  
 //write to all pins
 for (i  = 0; i <=5; i++){
     analogWrite(ledpin[i], value [i]);}
   n += skipSteps; // Time stepper. 
   delay(loopDelay); //Speed modifier
 }
